package sk.kasv.schmidt.javafx.worldx_gui.Controller;

import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.scene.Node;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.layout.AnchorPane;
import javafx.stage.Stage;
import sk.kasv.schmidt.javafx.worldx_gui.Main.WorldXApplication;

import java.io.IOException;

public class aboutController {
    public AnchorPane aboutGUI;
    public Label outputLabel;
    public Button buttonNumber1;
    public Button buttonNumber2;
    public Button buttonNumber7;
    public Button buttonNumber6;
    public Button buttonNumber5;
    public Button buttonNumber4;
    public Button buttonNumber3;
    public Button buttonNumber0;
    public Button buttonNumber9;
    public Button buttonNumber8;
    public Label outputLabelWin;
    public Button resetLabelButton;
    public Button restartButton;

    @FXML
    protected void initialize() {
        outputLabel.setText("");
        handleButtonAction();
    }

    public void handleButtonAction() {
        buttonNumber0.setOnAction(e -> {
            outputLabel.setText(outputLabel.getText() + "0");
            secretCodeGuessed();
            resetOutputLabelAfterTooManyNumbers("0");
        });
        buttonNumber1.setOnAction(e -> {
            outputLabel.setText(outputLabel.getText() + "1");
            secretCodeGuessed();
            resetOutputLabelAfterTooManyNumbers("1");
        });
        buttonNumber2.setOnAction(e -> {
            outputLabel.setText(outputLabel.getText() + "2");
            secretCodeGuessed();
            resetOutputLabelAfterTooManyNumbers("2");
        });
        buttonNumber3.setOnAction(e -> {
            outputLabel.setText(outputLabel.getText() + "3");
            secretCodeGuessed();
            resetOutputLabelAfterTooManyNumbers("3");
        });
        buttonNumber4.setOnAction(e -> {
            outputLabel.setText(outputLabel.getText() + "4");
            secretCodeGuessed();
            resetOutputLabelAfterTooManyNumbers("4");
        });
        buttonNumber5.setOnAction(e -> {
            outputLabel.setText(outputLabel.getText() + "5");
            secretCodeGuessed();
            resetOutputLabelAfterTooManyNumbers("5");
        });
        buttonNumber6.setOnAction(e -> {
            outputLabel.setText(outputLabel.getText() + "6");
            secretCodeGuessed();
            resetOutputLabelAfterTooManyNumbers("6");
        });
        buttonNumber7.setOnAction(e -> {
            outputLabel.setText(outputLabel.getText() + "7");
            secretCodeGuessed();
            resetOutputLabelAfterTooManyNumbers("7");
        });
        buttonNumber8.setOnAction(e -> {
            outputLabel.setText(outputLabel.getText() + "8");
            secretCodeGuessed();
            resetOutputLabelAfterTooManyNumbers("8");
        });
        buttonNumber9.setOnAction(e -> {
            outputLabel.setText(outputLabel.getText() + "9");
            secretCodeGuessed();
            resetOutputLabelAfterTooManyNumbers("9");
        });
    }
    public void resetOutputLabelAfterTooManyNumbers(String number){
        if (outputLabel.getText().length() >6) {
            outputLabel.setText(number);
        }
    }

    public void goBackFromAboutGUI(ActionEvent actionEvent) throws IOException {
        Stage stage = (Stage) ((Node) actionEvent.getSource()).getScene().getWindow();
        FXMLLoader fxmlLoader = new FXMLLoader(WorldXApplication.class.getResource("/sk/kasv/schmidt/javafx/worldx_gui/hello-view.fxml"));
        Scene scene = new Scene(fxmlLoader.load(),640, 480);
        stage.setTitle("About WorldX Application");
        stage.setScene(scene);
        stage.show();
    }

    public void secretCodeGuessed(){
        if (guessCode(outputLabel.getText())){
            outputLabelWin.setText("Congratulations! You have guessed the secret code!");
            buttonNumber0.setDisable(true);
            buttonNumber1.setDisable(true);
            buttonNumber2.setDisable(true);
            buttonNumber3.setDisable(true);
            buttonNumber4.setDisable(true);
            buttonNumber5.setDisable(true);
            buttonNumber6.setDisable(true);
            buttonNumber7.setDisable(true);
            buttonNumber8.setDisable(true);
            buttonNumber9.setDisable(true);
            resetLabelButton.setDisable(true);
        }
    }

    public boolean guessCode(String input) {
        String state = "START";

        for (char digit : input.toCharArray()) {
            switch (state) {
                case "START":
                    if (digit == '0') state = "0";
                    else state = "START";
                    break;
                case "0":
                    if (digit == '4') state = "4";
                    else state = "START";
                    break;
                case "4":
                    if (digit == '0') state = "0_2";
                    else state = "START";
                    break;
                case "0_2":
                    if (digit == '3') state = "3";
                    else state = "START";
                    break;
                case "3":
                    if (digit == '0') state = "0_3";
                    else state = "START";
                    break;
                case "0_3":
                    if (digit == '3') return true;
                    else state = "START";
                    break;
                default:
                    state = "START";
            }
        }
        return false;
    }

    public void resetOutputLabel(ActionEvent actionEvent) {
            outputLabel.setText("");
    }

    public void restartAppButton(ActionEvent actionEvent) {
        outputLabel.setText("");
        outputLabelWin.setText("");

        buttonNumber0.setDisable(false);
        buttonNumber1.setDisable(false);
        buttonNumber2.setDisable(false);
        buttonNumber3.setDisable(false);
        buttonNumber4.setDisable(false);
        buttonNumber5.setDisable(false);
        buttonNumber6.setDisable(false);
        buttonNumber7.setDisable(false);
        buttonNumber8.setDisable(false);
        buttonNumber9.setDisable(false);

        resetLabelButton.setDisable(false);
    }
}