package sk.kasv.schmidt.javafx.worldx_gui.Util;

import java.math.BigDecimal;
import java.math.RoundingMode;

public class utility {
    public static double roundToTwoDecimals(double value) {
        BigDecimal bd = new BigDecimal(value);
        bd = bd.setScale(2, RoundingMode.HALF_UP);
        return bd.doubleValue();
    }
    public static String prettifyPopulation(int population) {
        if (population >= 1_000_000_000) {
            return population / 1_000_000_000 + "B";
        } else if (population >= 1_000_000) {
            return population / 1_000_000 + "M";
        } else if (population >= 1_000) {
            return population / 1_000 + "K";
        } else {
            return String.valueOf(population);
        }
    }
}